@echo off

cd /d %~dp0

set OLD_CERTID=built-in
set NEW_CERTID=built-in-2
set NEW_CERTFILE=.\EDS-built-in-2.der
set TYPE=eds

set argc=0
for %%a in ( %* ) do set /a argc+=1


if not "%argc%"=="3" (
@echo %0 port binddn password
goto END1
)

set proc1=
set proc2=
for /f "usebackq tokens=*" %%i in (`net start ^| findstr /C:"EDS Manager"`) do @set proc1=%%i
for /f "usebackq tokens=*" %%j in (`net start ^| findstr /C:"EDS Protocol Server"`) do @set proc2=%%j
set procnum=0
if "%proc1%"=="EDS Manager" set /a procnum += 1
if "%proc2%"=="EDS Protocol Server" set /a procnum += 1

if not "%procnum%"=="2" (
@echo Please start EDS.
goto END2
)

set portno=%1
set binddn=%2
set passwd=%3

edcert -print -keyid "%OLD_CERTID%" >NUL 2>&1
if not "%ERRORLEVEL%"=="0" (
  @echo keyid %OLD_CERTID% is not exist.
  goto END3
)

edcert -print -keyid "%NEW_CERTID%" >NUL 2>&1
if "%ERRORLEVEL%"=="0" (
  @echo keyid %NEW_CERTID% is exist.
  @echo exit import process.
  goto END4
)

echo To import built-in certficate, EDS Server will be stopeed.
echo Do you want to continue?

set choice=
set /p choice=yes/no (default: no):
if not '%choice%'=='' set choice=%choice:~0,3%
if '%choice%'=='yes' goto YES
if not '%choice%'=='yes' goto NO
 
:YES
goto CONTINUE

:NO
echo Import process is canceled.
goto END0

:CONTINUE

edconfig -h localhost -p %portno% -D %binddn% -w %passwd% -view ldapCertificateKeyID
if not "%ERRORLEVEL%"=="0" (
  @echo view ldapCertificateKeyID failed.
  goto END5
)


set certid=
for /F "tokens=1,2" %%k in ('edconfig -h localhost -p %portno% -D %binddn% -w %passwd% -view ldapCertificateKeyID') do @set certid=%%l

setlocal enabledelayedexpansion
if "%certid%"=="%OLD_CERTID%" (
  @edconfig -h localhost -p %portno% -D %binddn% -w %passwd% -replace ldapCertificateKeyID:%NEW_CERTID%
  if not "!ERRORLEVEL!"=="0" (
    @echo replace ldapCertificateKeyID failed.
    @echo exit import process.
    goto END6
  )
)
endlocal

@net stop "EDS Protocol Server"
@net stop "EDS Manager"
echo Stopping EDS Server...

.\import_builtincert.exe -cert "%NEW_CERTFILE%" -type "%TYPE%" -keyid "%NEW_CERTID%"
if not "%ERRORLEVEL%" == "0" (
  @echo import %NEW_CERTFILE% failed.
  goto END7
)

setlocal enabledelayedexpansion
EDCACERT -list | findstr /C:"EDS built-in CA2" >NUL
if not "%ERRORLEVEL%"=="0" (
  EDCACERT -import -in .\cacert.der -trust -nocheck
  if not "!ERRORLEVEL!"=="0" (
    @echo "import CA cert failed."
    goto END8
  )
)
endlocal

@net start "EDS Protocol Server"
echo Starting EDS Server...

if not "%errorlevel%" == "0" (
  @echo start EDS failed.
  goto END9
)

echo success.
goto END0

:END0
exit /b 0

:END1
exit /b 1

:END2
exit /b 2

:END3
exit /b 3

:END4
exit /b 4

:END5
exit /b 5

:END6
exit /b 6

:END7
exit /b 7

:END8
exit /b 8

:END9
exit /b 9

PAUSE
